package com.zipcodewilmington.arrayutility;

import java.lang.reflect.Array;
import java.util.*;
import java.util.function.Consumer;
import java.util.stream.Stream;

/**
 * Created by leon on 3/6/18.
 */
public class ArrayUtility <T>{

    T[] array;

    public ArrayUtility(T[] array)
    {
        this.array= array;
    }



    Integer occurrences;


    public Integer countDuplicatesInMerge(T[] arrayToMerge, T valueToEvaluate) {

        List<T> list= new ArrayList<T>(Arrays.asList(array));

        list.addAll(Arrays.asList(arrayToMerge));

//        array = (T[]) Stream.concat(Arrays.stream(array), Arrays.stream(arrayToMerge))
//                .toArray(String[]::new);
        Integer count = 0;
        for(T dup: list){

            if(dup.equals(valueToEvaluate)){
                count++;
            }

        }

            return count;
    }

    public T getMostCommonFromMerge(T[] arrayToMerge) {

        List<T> list= new ArrayList<T>(Arrays.asList(array));

        list.addAll(Arrays.asList(arrayToMerge));


        Map<T, Integer> map = new HashMap<>();

        for (T t : list) {
            Integer val = map.get(t);
            map.put(t, val == null ? 1 : val + 1);
        }

        Map.Entry<T, Integer> max = null;

        for (Map.Entry<T, Integer> e : map.entrySet()) {
            if (max == null || e.getValue() > max.getValue())
                max = e;
        }

        return max.getKey();


    }

    public Integer getNumberOfOccurrences(T valueToEvaluate) {

        List<T> list= new ArrayList<T>(Arrays.asList(array));
        Integer occurrences = Collections.frequency(list, valueToEvaluate);

            return occurrences;
    }

    public T[] removeValue(T valueToRemove) {

        List<T> list = new ArrayList<>(Arrays.asList(array));
        List<T> list2 = new ArrayList<>();
        Consumer<T> consumer = (n) -> {
            if (n != valueToRemove) {
                list2.add(n);
            }

        };
            list.forEach(consumer);

            T[] object = (T[]) Array.newInstance(this.array.getClass().getComponentType(), list2.size());





        return (T[]) list2.toArray(object);

    }

}
